// let AsyncLock = require('async-lock')
// var lock = new AsyncLock();

import zlib from 'zlib';

// var lock_msgid sync.Mutex
function GetMessageId(prefix: string): string {
    // lock_msgid.Lock()
    // let messageId = await lock.acquire(prefix || "lockKey", async () => {});
    let time_now = Math.floor(Date.now() / 1000)
    let m_second = process.hrtime()[1]
    let ret = prefix + GetRandom() + "-" + time_now.toString(10) + "-" + m_second.toString(9)
    // lock_msgid.Unlock()
    return ret
}

// 获取时间戳
function GetTimestamp(): number {
    return Math.floor(Date.now() / 1000)
}

// gzip压缩字符串
function DoGZip(str:string, iszip: boolean | undefined): Buffer | string {
    return iszip ? zlib.gzipSync(str) : str
}

// 获取随机数
function GetRandom(): number {
    //如生成3位的随机数就定义100-999；
    //const max = 100;
    //const min = 999;
    //生成6位的随机数就定义100000-999999之间
    const min = 100000;                            //最小值
    const max = 999999;                            //最大值
    const range = max - min;                         //取值范围差
    const random = Math.random();                     //小于1的随机数
    const result = min + Math.round(random * range);  //最小数加随机数*范围差 
    return result;
}

export default {
    GetMessageId,
    GetTimestamp,
    DoGZip
}